

#include <stdbool.h>        // typedef bool
#include <stdint.h>         // typedef uint16_t

#include <avr/io.h>			// #define DDRB, #define PORTB, #define PB*
                            // #define DDRC, #define PORTC, #define PC*
                            // #define DDRD, #define PIND, #define PORTD,
                            // #define PD*

#include <avr/interrupt.h>  // #define sei()
#include <util/delay.h>     // _delay_ms()
#include <avr/pgmspace.h>   // #define PSTR()

#include "sysdef.h"         // -- hw defines required by following includes ----
                            // #define F_CPU, #define BOARD_DEFINED_IN_SYSDEF,
                            // #define LN_*

#include "ln_interface.h"   // initLocoNet(), recvLocoNetPacket()
#include "loconet.h"        // typedef lnMsg, typedef LnBuf, initLnBuf()
//#include "BootloaderUser.h" // -- application support module for bootloader ----
                            // BootloaderParseMessage(), BootloaderEnter()
//#include "vprintf.h"        // _printf_P(),
#include "user_conf.h"
//#include "i2cmaster.h"
#include "Delay.h"

int ergebnis;
byte track_status=0;
byte state=0;
char stelle=0;
int loco_adr=0;
int rxadresse=0;
int zaehler1 = 0;
int zaehler2 = 0;

int stoerung1=0;

byte inputstate[4];
byte weichenstate[3];

LN_STATUS LnStatus ;
rwSlotDataMsg steuerslot;

void init_inputs(void);



void init_inputs(void){
	DDRD &= ~((1 << DDD5) | (1 << DDD6)| (1 << DDD7));
	PORTD |= (1<<PORTD5) | (1<<PORTD6)| (1<<PORTD7);
	DDRB &= ~(1 << DDB0);
	PORTB |= (1<<PORTB0);
	inputstate[0]=0;
	inputstate[1]=0;
	inputstate[2]=0;
	inputstate[3]=0;
	weichenstate[0]=0;
	weichenstate[1]=0;
	weichenstate[2]=0;
}


void SendSWReq(int weiche, byte state){
	int tweiche, tweiche2;

	tweiche=weiche;
	tweiche2=0;
	if (weiche>127){
		tweiche2=weiche/128;
		tweiche=weiche-(tweiche2*128);
				}
		if (state==1) tweiche2|=(1<<5);
		int tweiche3 = tweiche2;
		tweiche2|=(1<<4);
		sendLocoNet4BytePacket(OPC_SW_REQ, tweiche,tweiche2);
		Delay_ms(8);
		sendLocoNet4BytePacket(OPC_SW_REQ, tweiche,tweiche3);
}


void led1_aus(){
	DDRC |= (1 << DDC0);
	PORTC |= (1<<PORTC0);

}

void led1_an(){
 //	DDRD &=~(1<<PORTD2);
	PORTC &=~(1<<PORTC0);

}


void led2_aus(){
	DDRC |= (1 << DDC1);
	PORTC |= (1<<PORTC1);

}

void led2_an(){
	PORTC &=~(1<<PORTC1);

}

void led3_aus(){
	DDRC |= (1 << DDC2);
	PORTC |= (1<<PORTC2);

}

void led3_an(){
	PORTC &=~(1<<PORTC2);

}

void led4_aus(){
	DDRC |= (1 << DDC3);
	PORTC |= (1<<PORTC3);

}

void led4_an(){
	PORTC &=~(1<<PORTC3);

}

void led5_aus(){
	DDRC |= (1 << DDC4);
	PORTC |= (1<<PORTC4);

}

void led5_an(){
	PORTC &=~(1<<PORTC4);

}

void led6_aus(){
	DDRC |= (1 << DDC5);
	PORTC |= (1<<PORTC5);

}

void led6_an(){
	PORTC &=~(1<<PORTC5);

}


void led7_aus(){
	DDRB |= (1 << DDB1);
	PORTB |= (1<<PORTB1);

}

void led7_an(){
	PORTB &=~(1<<PORTB1);

}

void init_leds(void){
	led1_aus();
	led2_aus();
	led3_aus();
	led4_aus();
	led5_aus();
	led6_aus();
	led7_aus();
	Delay_ms(50);
	led7_an();
	Delay_ms(50);
	led1_an();
	Delay_ms(50);
	led2_an();
	Delay_ms(50);
	led3_an();
	Delay_ms(50);
	led4_an();
	Delay_ms(50);
	led5_an();
	Delay_ms(50);
	led6_an();
	Delay_ms(350);
	led7_an();
	led1_aus();
		led2_aus();
		led3_aus();
		led4_aus();
		led5_aus();
		led6_aus();
}


void procSWREQ(int adresse, byte anaus){
    if ((adresse==22)&&(inputstate[0]==1)){
    	if (anaus==1){
    		if(weichenstate[0]==0){
    			SendSWReq(15,0);
    			weichenstate[0]=1;
    			led3_an();
    			led4_aus();
    		}
    		else{
    			SendSWReq(15,1);
    			weichenstate[0]=0;
    			led4_an();
    			led3_aus();
    		}
    	}

    }
    if ((adresse==21)&&(inputstate[0]==1)){
        	if (anaus==1){
        		if(weichenstate[1]==0){
        			SendSWReq(14,1);
        			weichenstate[1]=1;
        			led2_an();
        			led1_aus();
        		}
        		else{
        			SendSWReq(14,0);
        			weichenstate[1]=0;
        			led1_an();
        			led2_aus();
        		}
        	}

        }
    if ((adresse==23)&&(inputstate[0]==1)){
            	if (anaus==1){
            		if(weichenstate[2]==0){
            			SendSWReq(13,1);
            			SendSWReq(12,1);
            			weichenstate[2]=1;
            			led5_an();
            			led6_aus();
            		}
            		else{
            			SendSWReq(13,0);
            			SendSWReq(12,0);
            			weichenstate[2]=0;
            			led6_an();
            			led5_aus();
            		}
            	}

            }

	if (adresse==output_adr[4]){
		if (anaus==1) led1_an();
		else led1_aus();
		}
	if (adresse==output_adr[5]){
		if (anaus==1) led2_an();
		else led2_aus();
		}
	if (adresse==output_adr[6]){
		if (anaus==1) led3_an();
		else led3_aus();
		}
	if (adresse==output_adr[7]){
		if (anaus==1) led4_an();
		else led4_aus();
		}
	if (adresse==output_adr[8]){
		if (anaus==1) led5_an();
		else led5_aus();
		}
	if (adresse==output_adr[9]){
		if (anaus==1) led6_an();
		else led6_aus();
		}
	if (adresse==output_adr[10]){
		if (anaus==1) led7_an();
		else led7_aus();
		}

}




static void HandleLoconetReception(void)
{
	lnMsg *LnPacket = recvLocoNetPacket();

	if( LnPacket->sd.command == OPC_GPON ){
		LnStatus =sendLocoNet4BytePacket(0xbf,0x00,0x08);

	}

	if (LnPacket->sd.command == OPC_SW_REQ) {
		int	rxadresse = ((LnPacket->data[2] & 0x0f) <<7); // A10, A9, A8, A7 * 128
		rxadresse |= (LnPacket->data[1] & 0x7f); // += A6, A5, A4, A3, A2, A1, A0
		byte anaus = 0;
		if (LnPacket->data[2]&(1<<5)) anaus = 1;
		procSWREQ(rxadresse,anaus);
	}


}




void SendInputMessage(byte input, byte state){
	int tweiche, tweiche2;

	tweiche=input_adr[input];
	tweiche2=0;
	if (input_adr[input]>127){
		tweiche2=input_adr[input]/128;
		tweiche=input_adr[input]-(tweiche2*128);
				}
		if (state==1) tweiche2|=(1<<5);
		tweiche2|=(1<<4);
		sendLocoNet4BytePacket(OPC_SW_REQ, tweiche,tweiche2);
}


void read_inputs(){
	if ( !(PIND & (1<<PIND5)) ) {
		if (inputstate[0]==0){
			Delay_ms(1);
			if ( !(PIND & (1<<PIND5)) ) {
				SendInputMessage(0, 1);
				inputstate[0]=1;
				}
		}
	}

	else if ( PIND & (1<<PIND5) ) {
		if (inputstate[0]==1){
			Delay_ms(1);
			if ( PIND & (1<<PIND5) ) {
				SendInputMessage(0, 0);
				inputstate[0]=0;
				}
		}
	}
	if ( !(PIND & (1<<PIND6)) ) {
		if (inputstate[1]==0){
			Delay_ms(1);
			if ( !(PIND & (1<<PIND6)) ) {
				SendInputMessage(1, 1);
				inputstate[1]=1;
				}
		}
	}
	else if ( PIND & (1<<PIND6) ) {
		if (inputstate[1]==1){
			Delay_ms(1);
			if ( PIND & (1<<PIND6) ) {
				SendInputMessage(1, 0);
				inputstate[1]=0;
			}
		}
	}
	if ( !(PIND & (1<<PIND7)) ) {
		if (inputstate[2]==1){
			Delay_ms(1);
			if ( !(PIND & (1<<PIND7)) ) {
				SendInputMessage(2, 1);
				inputstate[2]=0;
				}
		}
	}
	else if ( PIND & (1<<PIND7) ) {
		if (inputstate[2]==0){
			Delay_ms(1);
			if ( PIND & (1<<PIND7) ) {
				SendInputMessage(2, 0);
				inputstate[2]=1;
				}
		}
	}
	if ( !(PINB & (1<<PINB0)) ) {
		if (inputstate[3]==0){
			Delay_ms(1);
			if ( !(PINB & (1<<PINB0)) ) {
				SendInputMessage(3, 1);
				inputstate[3]=1;
				}
		}
	}
	else if ( PINB & (1<<PINB0) ) {
		if (inputstate[3]==1){
			Delay_ms(1);
			if ( PINB & (1<<PINB0) ) {
				SendInputMessage(3, 0);
				inputstate[3]=0;
				}
		}
	}

}

int main(void)
{
	//---- Initialize I/O Ports ------------------------------------------------
/*	DDRD = 0xff;

DDRB &= ~( 1 << DDB0 );
DDRB &= ~( 1 << DDB1 );
PORTB |= (1<<PB1);
PORTB |= (1<<PB0);

*/




Delay_ms(20);


	//---- Initialize LocoNet --------------------------------------------------
	static LnBuf stLnBuffer;
	initLnBuf( &stLnBuffer );
	initLocoNet( &stLnBuffer );
	sbi(LN_TX_DDR, LN_TX_BIT);

	//---- now we start do live :-) --------------------------------------------
	sei();

//	static uint16_t count = 0;

	Delay_ms(20);

	ergebnis = 24;

	init_inputs();

//	i2c_init();

//	LnStatus =sendLocoNet4BytePacket(0xbf,0x00,0x0A);

	SendInputMessage(0, 0);
	//SendInputMessage(output_adr[1], 0);

	Delay_ms(20);
    init_leds();

	while(1)
	{

	HandleLoconetReception();

	zaehler1++;
			if (zaehler1>100){
				zaehler2++;
				zaehler1=0;
		}
			if (zaehler2>100){
			read_inputs();
	//		read_ext_inputs();
			//LnStatus =sendLocoNet4BytePacket(0xbf,0x00,0x0A);
			zaehler2=0;
	}







	}
}
